//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.IntegrationTests;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.IntegrationTests
{
    
    
    /// <summary>
    /// A class that exposes the ITestServer interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class TestServerProvider : IFeatureProvider
    {
        
        private ITestServer _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(TestServerProvider).Assembly, "TestServer.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public TestServerProvider(ITestServer implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        private System.Exception ConvertWaitForCancelOrThrowExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "duration"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/WaitForCancelOrThrow/Parameter/" +
                            "Duration", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (ShouldHaveBeenCancelledException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("tecan.sila/integrationtests/TestServer/v1/DefinedExecutionError/ShouldHaveBeenCan" +
                        "celled", "", ex.Message);
            }
        }
        
        private System.Exception ConvertRunIntoFailureObservablyExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (FakeException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("tecan.sila/integrationtests/TestServer/v1/DefinedExecutionError/Fake", "", ex.Message);
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<PassBoolRequestDto, PassBoolResponseDto>("PassBool", PassBool);
            registration.RegisterUnobservableCommand<PassDoubleRequestDto, PassDoubleResponseDto>("PassDouble", PassDouble);
            registration.RegisterUnobservableCommand<PassLongRequestDto, PassLongResponseDto>("PassLong", PassLong);
            registration.RegisterUnobservableCommand<PassIntRequestDto, PassIntResponseDto>("PassInt", PassInt);
            registration.RegisterUnobservableCommand<PassTimestampRequestDto, PassTimestampResponseDto>("PassTimestamp", PassTimestamp);
            registration.RegisterUnobservableCommand<PassTimeRequestDto, PassTimeResponseDto>("PassTime", PassTime);
            registration.RegisterUnobservableCommand<PassStringRequestDto, PassStringResponseDto>("PassString", PassString);
            registration.RegisterUnobservableCommand<PassStreamRequestDto, PassStreamResponseDto>("PassStream", PassStream);
            registration.RegisterBinaryCommandParameter("tecan.sila/integrationtests/TestServer/v1/Command/PassStream/Parameter/Value");
            registration.RegisterUnobservableCommand<PassFileRequestDto, PassFileResponseDto>("PassFile", PassFile);
            registration.RegisterBinaryCommandParameter("tecan.sila/integrationtests/TestServer/v1/Command/PassFile/Parameter/File");
            registration.RegisterUnobservableCommand<PassBytesRequestDto, PassBytesResponseDto>("PassBytes", PassBytes);
            registration.RegisterBinaryCommandParameter("tecan.sila/integrationtests/TestServer/v1/Command/PassBytes/Parameter/Bytes");
            registration.RegisterUnobservableCommand<PassDynamicRequestDto, PassDynamicResponseDto>("PassDynamic", PassDynamic);
            registration.RegisterUnobservableCommand<PassCollectionRequestDto, PassCollectionResponseDto>("PassCollection", PassCollection);
            registration.RegisterUnobservableCommand<PassStructureRequestDto, PassStructureResponseDto>("PassStructure", PassStructure);
            registration.RegisterObservableCommand<RunObservableRequestDto, int, RunObservableResponseDto>("RunObservable", RunObservable, ConvertRunObservableResponse, null);
            registration.RegisterCommandWithIntermediates<RunIntermediateObservableCommandRequestDto, int, RunIntermediateObservableCommandIntermediateDto>("RunIntermediateObservableCommand", RunIntermediateObservableCommand, ConvertRunIntermediateObservableCommandIntermediate, null);
            registration.RegisterObservableCommand<WaitForCancelOrThrowRequestDto>("WaitForCancelOrThrow", WaitForCancelOrThrow, ConvertWaitForCancelOrThrowExceptions);
            registration.RegisterUnobservableCommand<RunIntoFailureRequestDto, EmptyRequest>("RunIntoFailure", RunIntoFailure);
            registration.RegisterObservableCommand<RunIntoFailureObservablyRequestDto>("RunIntoFailureObservably", RunIntoFailureObservably, ConvertRunIntoFailureObservablyExceptions);
            registration.RegisterUnobservableCommand<IsCancelledRequestDto, IsCancelledResponseDto>("IsCancelled", IsCancelled);
            registration.RegisterUnobservableCommand<ThrowRuntimeExceptionRequestDto, EmptyRequest>("ThrowRuntimeException", ThrowRuntimeException);
            registration.RegisterUnobservableCommand<SetDummyRequestDto, EmptyRequest>("SetDummy", SetDummy);
            registration.RegisterObservableProperty("DummyValue", GetDummyValue, _implementation);
        }
        
        /// <summary>
        /// Executes the Pass Bool command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassBoolResponseDto PassBool(PassBoolRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassBoolResponseDto(_implementation.PassBool(request.Data.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassBool/Parameter/Data")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "data"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassBool/Parameter/Data", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Double command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassDoubleResponseDto PassDouble(PassDoubleRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassDoubleResponseDto(_implementation.PassDouble(request.Data.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassDouble/Parameter/Data")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "data"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassDouble/Parameter/Data", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Long command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassLongResponseDto PassLong(PassLongRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassLongResponseDto(_implementation.PassLong(request.Data.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassLong/Parameter/Data")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "data"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassLong/Parameter/Data", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Int command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassIntResponseDto PassInt(PassIntRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassIntResponseDto(_implementation.PassInt(((int)(request.Data.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassInt/Parameter/Data")))), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "data"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassInt/Parameter/Data", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Timestamp command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassTimestampResponseDto PassTimestamp(PassTimestampRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassTimestampResponseDto(_implementation.PassTimestamp(request.Timestamp.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassTimestamp/Parameter/Timesta" +
                                "mp")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "timestamp"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassTimestamp/Parameter/Timesta" +
                            "mp", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Time command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassTimeResponseDto PassTime(PassTimeRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassTimeResponseDto(_implementation.PassTime(request.Time.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassTime/Parameter/Time")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "time"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassTime/Parameter/Time", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass String command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassStringResponseDto PassString(PassStringRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassStringResponseDto(_implementation.PassString(request.Value.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassString/Parameter/Value")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "value"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassString/Parameter/Value", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Stream command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassStreamResponseDto PassStream(PassStreamRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassStreamResponseDto(_implementation.PassStream(request.Value.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassStream/Parameter/Value")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "value"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassStream/Parameter/Value", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass File command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassFileResponseDto PassFile(PassFileRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassFileResponseDto(_implementation.PassFile(request.File.TryExtractToFileInfo(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassFile/Parameter/File")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "file"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassFile/Parameter/File", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Bytes command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassBytesResponseDto PassBytes(PassBytesRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassBytesResponseDto(_implementation.PassBytes(request.Bytes.TryExtractToBytes(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassBytes/Parameter/Bytes")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "bytes"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassBytes/Parameter/Bytes", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Dynamic command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassDynamicResponseDto PassDynamic(PassDynamicRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassDynamicResponseDto(_implementation.PassDynamic(request.Dynamic.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassDynamic/Parameter/Dynamic")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "dynamic"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassDynamic/Parameter/Dynamic", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Collection command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassCollectionResponseDto PassCollection(PassCollectionRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassCollectionResponseDto(_implementation.PassCollection(request.Strings.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassCollection/Parameter/String" +
                                "s")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "strings"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassCollection/Parameter/String" +
                            "s", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Pass Structure command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual PassStructureResponseDto PassStructure(PassStructureRequestDto request)
        {
            try
            {
                request.Validate();
                return new PassStructureResponseDto(_implementation.PassStructure(request.Structure.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/PassStructure/Parameter/Structu" +
                                "re")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "structure"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/PassStructure/Parameter/Structu" +
                            "re", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        private RunObservableResponseDto ConvertRunObservableResponse(int result)
        {
            return new RunObservableResponseDto(result, _server);
        }
        
        /// <summary>
        /// Executes the Run Observable command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand<int> RunObservable(RunObservableRequestDto request)
        {
            request.Validate();
            return _implementation.RunObservable();
        }
        
        private RunIntermediateObservableCommandIntermediateDto ConvertRunIntermediateObservableCommandIntermediate(int intermediate)
        {
            return new RunIntermediateObservableCommandIntermediateDto(intermediate, _server);
        }
        
        /// <summary>
        /// Executes the Run Intermediate Observable Command command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IIntermediateObservableCommand<int> RunIntermediateObservableCommand(RunIntermediateObservableCommandRequestDto request)
        {
            request.Validate();
            return _implementation.RunIntermediateObservableCommand();
        }
        
        /// <summary>
        /// Executes the Wait For Cancel Or Throw command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand WaitForCancelOrThrow(WaitForCancelOrThrowRequestDto request)
        {
            request.Validate();
            return new WaitForCancelOrThrowCommand(this, request);
        }
        
        /// <summary>
        /// Executes the Run Into Failure command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest RunIntoFailure(RunIntoFailureRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.RunIntoFailure();
                return EmptyRequest.Instance;
            } catch (FakeException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("tecan.sila/integrationtests/TestServer/v1/DefinedExecutionError/Fake", "", ex.Message);
            }
        }
        
        /// <summary>
        /// Executes the Run Into Failure Observably command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand RunIntoFailureObservably(RunIntoFailureObservablyRequestDto request)
        {
            request.Validate();
            return new RunIntoFailureObservablyCommand(this, request);
        }
        
        /// <summary>
        /// Executes the Is Cancelled command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual IsCancelledResponseDto IsCancelled(IsCancelledRequestDto request)
        {
            try
            {
                request.Validate();
                return new IsCancelledResponseDto(_implementation.IsCancelled(request.CommandId.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/IsCancelled/Parameter/CommandId" +
                                "")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "commandId"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/IsCancelled/Parameter/CommandId" +
                            "", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Throw Runtime Exception command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest ThrowRuntimeException(ThrowRuntimeExceptionRequestDto request)
        {
            request.Validate();
            _implementation.ThrowRuntimeException();
            return EmptyRequest.Instance;
        }
        
        /// <summary>
        /// Executes the Set Dummy command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest SetDummy(SetDummyRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.SetDummy(((int)(request.Value.TryExtract(_server, "tecan.sila/integrationtests/TestServer/v1/Command/SetDummy/Parameter/Value"))));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "value"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila/integrationtests/TestServer/v1/Command/SetDummy/Parameter/Value", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Dummy Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetDummyValue()
        {
            return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.DummyValue, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassBool"))
            {
                return typeof(ITestServer).GetMethod("PassBool");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassDouble"))
            {
                return typeof(ITestServer).GetMethod("PassDouble");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassLong"))
            {
                return typeof(ITestServer).GetMethod("PassLong");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassInt"))
            {
                return typeof(ITestServer).GetMethod("PassInt");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassTimestamp"))
            {
                return typeof(ITestServer).GetMethod("PassTimestamp");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassTime"))
            {
                return typeof(ITestServer).GetMethod("PassTime");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassString"))
            {
                return typeof(ITestServer).GetMethod("PassString");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassStream"))
            {
                return typeof(ITestServer).GetMethod("PassStream");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassFile"))
            {
                return typeof(ITestServer).GetMethod("PassFile");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassBytes"))
            {
                return typeof(ITestServer).GetMethod("PassBytes");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassDynamic"))
            {
                return typeof(ITestServer).GetMethod("PassDynamic");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassCollection"))
            {
                return typeof(ITestServer).GetMethod("PassCollection");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/PassStructure"))
            {
                return typeof(ITestServer).GetMethod("PassStructure");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/RunObservable"))
            {
                return typeof(ITestServer).GetMethod("RunObservable");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/RunIntermediateObservableComman" +
                "d"))
            {
                return typeof(ITestServer).GetMethod("RunIntermediateObservableCommand");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/WaitForCancelOrThrow"))
            {
                return typeof(ITestServer).GetMethod("WaitForCancelOrThrow");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/RunIntoFailure"))
            {
                return typeof(ITestServer).GetMethod("RunIntoFailure");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/RunIntoFailureObservably"))
            {
                return typeof(ITestServer).GetMethod("RunIntoFailureObservably");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/IsCancelled"))
            {
                return typeof(ITestServer).GetMethod("IsCancelled");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/ThrowRuntimeException"))
            {
                return typeof(ITestServer).GetMethod("ThrowRuntimeException");
            }
            if ((commandIdentifier == "tecan.sila/integrationtests/TestServer/v1/Command/SetDummy"))
            {
                return typeof(ITestServer).GetMethod("SetDummy");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "tecan.sila/integrationtests/TestServer/v1/Property/DummyValue"))
            {
                return typeof(ITestServer).GetProperty("DummyValue");
            }
            return null;
        }
        
        private class WaitForCancelOrThrowCommand : Tecan.Sila2.ObservableCommand
        {
            
            private TestServerProvider _parent;
            
            private WaitForCancelOrThrowRequestDto _request;
            
            public WaitForCancelOrThrowCommand(TestServerProvider parent, WaitForCancelOrThrowRequestDto request) : 
                    base(new System.Threading.CancellationTokenSource())
            {
                _parent = parent;
                _request = request;
            }
            
            public override System.Threading.Tasks.Task Run()
            {
                return _parent._implementation.WaitForCancelOrThrow(_request.Duration.TryExtract(_parent._server, "tecan.sila/integrationtests/TestServer/v1/Command/WaitForCancelOrThrow/Parameter/" +
                            "Duration"), CancellationToken);
            }
        }
        
        private class RunIntoFailureObservablyCommand : Tecan.Sila2.ObservableCommand
        {
            
            private TestServerProvider _parent;
            
            private RunIntoFailureObservablyRequestDto _request;
            
            public RunIntoFailureObservablyCommand(TestServerProvider parent, RunIntoFailureObservablyRequestDto request) : 
                    base(new System.Threading.CancellationTokenSource())
            {
                _parent = parent;
                _request = request;
            }
            
            public override System.Threading.Tasks.Task Run()
            {
                return System.Threading.Tasks.Task.Factory.StartNew(RunCore, CancellationToken);
            }
            
            private void RunCore()
            {
                _parent._implementation.RunIntoFailureObservably(CancellationToken);
            }
        }
    }
}


